create database if not exists `intimate_source`;
use intimate_source;

CREATE TABLE IF NOT EXISTS `source_openrec` (
	uid bigint AUTO_INCREMENT COMMENT '自增UID',

	`streamer_id` bigint DEFAULT NULL COMMENT 'streamer uid, 关联主播',
	`url` text NOT NULL COMMENT '获取源数据地址',
	`source` longtext DEFAULT NULL COMMENT '源数据',
	`ext` json DEFAULT NULL COMMENT '扩展字段',
	`serialize` blob DEFAULT NULL COMMENT '需要给下个任务传递 序列花数据, 非必要不用',
	`update_time` Timestamp  NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新数据',
	`error_msg` text DEFAULT NULL COMMENT '错误信息',

	`target_type` varchar(64) NOT NULL COMMENT '目标类型',
	`operator` int DEFAULT 0 COMMENT '操作标志位, 根据不同解析方法有不同标志',
	PRIMARY KEY(`uid`),
	KEY `operator_idx` (`operator`),
	KEY `update_time_idx` (`update_time`),
	KEY `target_type_idx` (`target_type`)
 );


 CREATE TABLE IF NOT EXISTS `source_twitch` (
	uid bigint AUTO_INCREMENT COMMENT '自增UID',

	`streamer_id` bigint DEFAULT NULL COMMENT 'streamer uid, 关联主播',
	`url` text NOT NULL COMMENT '获取源数据地址',
	`source` longtext DEFAULT NULL COMMENT '源数据',
	`ext` json DEFAULT NULL COMMENT '扩展字段',
	`serialize` blob DEFAULT NULL COMMENT '需要给下个任务传递 序列花数据, 非必要不用',
	`update_time` Timestamp  NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新数据',
	`error_msg` text DEFAULT NULL COMMENT '错误信息',

	`target_type` varchar(64) NOT NULL COMMENT '目标类型',
	`operator` int DEFAULT 0 COMMENT '操作标志位, 根据不同解析方法有不同标志',
	PRIMARY KEY(`uid`),
	KEY `operator_idx` (`operator`),
	KEY `update_time_idx` (`update_time`),
	KEY `target_type_idx` (`target_type`)
 );